/* ccgo: igsconn.hh
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <gtk--.h>
#include <sigc++/object.h>
#include <sigc++/basic_signal.h>
#include <string>

class IgsConn :
	public SigC::Object
{
public:
	IgsConn();
	~IgsConn();
	SigC::Signal1<void, const std::string &> line_ready;
	void send_line(const std::string &);
	SigC::Signal0<void> conn_lost;
	bool more_line();
private:
	int to_child;
	int from_child;
	pid_t child_pid;
	SigC::Connection con_grab_line;
	void grab_line(int, GdkInputCondition);
	SigC::Connection con_timeup;
	gint timeup();
	std::string line_buffer;
	int idle_time;
	bool more_to_come;
};
